/* 기본 설정 데이터 */
struct _configdata {
	char *exec_path;
	char *rompath;
	char *tmp_path;
};

typedef struct _configdata s_confdata;

/* 렌더러 설정 데이터 */
struct _rendererconf {
	unsigned short int res_x;		// 가로 해상도
	unsigned short int res_y;		// 세로 해상도
	unsigned short int fullscreen;	// 풀스크린 (0=false/1=true) 
	unsigned short int color_depth;	// 색상 깊이 (16/32)
	unsigned short int scanlines;	// 스캔라인 (0=none/1=black/2=bright)
	unsigned short int filtering;	// 텍스쳐 필터링 (0/1/2/3) 
	unsigned short int blending;	// 블렌딩 (opengl: 0/1, D3D: 0/1/2)
	unsigned short int dithering;	// 디더링 (0=false/1=true)
	unsigned short int showfps;		// FPS 보여주기 여부(0=false/1=true)
	unsigned short int frame_limit;	// 프레임 제한 여부 (0=false/1=true)
	unsigned short int frame_skip;	// 프레임 skipping (0=false/1=true)
	unsigned short int frame_det;	// 자동 프레임레이트 검출 (0/1)
	unsigned short int framerate;	// 수동 프레임 레이트(0~1000)
	unsigned short int tex_type;	// 텍스쳐 타입(0=def/1=4bit/2=5bit/3=8bit)
	unsigned short int tex_cache;	// 텍스쳐 캐시(0/1/2, 권장 2)
	unsigned short int turn_disp;	// turn display (0=기본, 0/1/2, not tested)
};

typedef struct _rendererconf s_rendconf;

/* 윈도우 관련 정보 데이터 구조체 */
struct _windowconf {
	int root_x;
	int root_y;
	int width;
	int height;
};

typedef struct _windowconf s_windowconf;


/* 공용 인터페이스 */
short int config_read (const char *filename, int type);

/* 기본 설정 인터페이스 */
short int config_write (void);
short int config_keyval_set (const gchar *key, const gchar *value);
const gchar * config_keyval_get (const gchar *key);

/* 렌더러 설정 인터페이스 */
short int rend_conf_write (void);
short int rend_conf_keyval_set (const gchar *key, const gchar *value);
unsigned short int rend_conf_keyval_get (const gchar *key);

/* 윈도우 키 값 리턴/설정 인터페이스 */
int wininfo_keyval_get (const gchar *key);
void wininfo_set_val (int x, int y, int width, int height);
