/* Main / Program Init Modules
 *
 * TODO:
 *  1. configuation init/load/save (Landed.)
 *  2. synch-ed spawn ZiNc Process by double-clicking treeview items (Landed.)
 *  3. artwork-treeview item matching (Landed.)
 *  4. joystick configuration? -_-; (at Risk)
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <glib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include <glade/glade.h>

#include "gzinc-types.h"
#include "zinc-exec.h"
#include "configurator.h"
#include "../config-path.h"

GladeXML *gp_xml_main = NULL;

void gs_treeview_init (void)
{
	GtkWidget *p_gs_tree = glade_xml_get_widget (gp_xml_main, "gs_treeview");

	GtkCellRenderer *rend_gs_treeview = NULL;

	rend_gs_treeview = gtk_cell_renderer_text_new ();
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (p_gs_tree),
		-1, "Number", rend_gs_treeview, "text", GS_GAME_NUM, NULL);
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (p_gs_tree),
		-1, "Title", rend_gs_treeview, "text", GS_GAME_TITLE, NULL);
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (p_gs_tree),
		-1, "Romfile", rend_gs_treeview, "text", GS_GAME_ROM, NULL);
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (p_gs_tree),
		-1, "Parent", rend_gs_treeview, "text", GS_PARENT_ROM, NULL);
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (p_gs_tree),
		-1, "BIOS", rend_gs_treeview, "text", GS_BIOS, NULL);
}

void gs_config_init (void)
{
	GtkWidget *zinc_exec_entry = glade_xml_get_widget (gp_xml_main,
						"zinc_exec_entry");
	GtkWidget *rom_dir_entry = glade_xml_get_widget (gp_xml_main,
						"rom_dir_entry");
	GtkWidget *tmp_dir_entry = glade_xml_get_widget (gp_xml_main,
						"tmp_dir_entry");
	GtkWidget *main_window = glade_xml_get_widget (gp_xml_main,
						"main_window");

	if (NULL != config_keyval_get ("rompath_dir"))
		gtk_entry_set_text (GTK_ENTRY (rom_dir_entry), config_keyval_get ("rompath_dir"));
	if (NULL != config_keyval_get ("exec_dir"))
		gtk_entry_set_text (GTK_ENTRY (zinc_exec_entry), config_keyval_get ("exec_dir"));
	if (NULL != config_keyval_get ("tmp_dir"))
		gtk_entry_set_text (GTK_ENTRY (tmp_dir_entry), config_keyval_get ("tmp_dir"));

	// 윈도우를 이전 위치, 크기로 복귀, 설정 파일이 없으면 기본값이 들어감.
	// 기본값은 root_x 10, root_y 10
	// *주의* 시작때는 gdk_window_move_resize() 를 쓰면 된다. 
	gdk_window_move_resize (GDK_WINDOW (main_window->window), 
								wininfo_keyval_get ("gzinc_root_x"),
								wininfo_keyval_get ("gzinc_root_y"),
								wininfo_keyval_get ("gzinc_width"),
								wininfo_keyval_get ("gzinc_height"));
	
	return;
}

void gs_rend_conf_init (void)
{
	gchar temp[12] = "";
	GtkWidget *widget = NULL;

	// 해상도 X
	widget = glade_xml_get_widget (gp_xml_main, "entry_res_x");
	g_snprintf (temp, 12, "%d", rend_conf_keyval_get ("XSize"));
	gtk_entry_set_text (GTK_ENTRY (widget), temp);
	
	// 해상도 Y
	widget = glade_xml_get_widget (gp_xml_main, "entry_res_y");
	g_snprintf (temp, 12, "%d", rend_conf_keyval_get ("YSize"));
	gtk_entry_set_text (GTK_ENTRY (widget), temp);

	// 전체화면 여부
	widget = glade_xml_get_widget (gp_xml_main, "cb_fullscreen");
	if (0 == rend_conf_keyval_get ("FullScreen"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	// 컬러 depth 설정
	if (16 == rend_conf_keyval_get ("ColorDepth")) {
		widget = glade_xml_get_widget (gp_xml_main, "rb_16bit");
		gtk_button_clicked (GTK_BUTTON (widget));
	}
	else {
		widget = glade_xml_get_widget (gp_xml_main, "rb_32bit");
		gtk_button_clicked (GTK_BUTTON (widget));
	}

	// scanline 설정
	widget = glade_xml_get_widget (gp_xml_main, "combobox_scanline");
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget), rend_conf_keyval_get ("ScanLines"));

	// filtering 설정
	g_snprintf (temp, 12, "rb_tf_%d", rend_conf_keyval_get ("Filtering"));
	widget = glade_xml_get_widget (gp_xml_main, temp);
	gtk_button_clicked (GTK_BUTTON (widget));

	// blending 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_ecb");
	if (0 == rend_conf_keyval_get ("Blending"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
	
	// dithering 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_dither");
	if (0 == rend_conf_keyval_get ("Dithering"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	// showfps 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_showfps");
	if (0 == rend_conf_keyval_get ("ShowFPS"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	// frame limitation 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_framelimit");
	if (0 == rend_conf_keyval_get ("FrameLimitation"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	// frame skipping 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_frameskip");
	if (0 == rend_conf_keyval_get ("FrameSkipping"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
	
	// Auto Framerate Detection 설정
	widget = glade_xml_get_widget (gp_xml_main, "cb_afrd");
	if (0 == rend_conf_keyval_get ("FramerateDetection"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	// Manual Framerate 설정
	widget = glade_xml_get_widget (gp_xml_main, "manual_frate");
	gtk_range_set_value (GTK_RANGE (widget), (gdouble) rend_conf_keyval_get ("FramerateManual"));

	// Texture type 설정
	g_snprintf (temp, 12, "rb_tex_%d", rend_conf_keyval_get ("TextureType"));
	widget = glade_xml_get_widget (gp_xml_main, temp);
	gtk_button_clicked (GTK_BUTTON (widget));

	// Texture cache 설정
	g_snprintf (temp, 12, "rb_cache_%d", rend_conf_keyval_get ("TextureCaching"));
	widget = glade_xml_get_widget (gp_xml_main, temp);
	gtk_button_clicked (GTK_BUTTON (widget));

	// Turn Display 설정
	g_snprintf (temp, 12, "rb_rotate_%d", rend_conf_keyval_get ("TurnDisplay"));
	widget = glade_xml_get_widget (gp_xml_main, temp);
	gtk_button_clicked (GTK_BUTTON (widget));

	// 완료. 일단 설정을 저장 한다.
	rend_conf_write ();
	return;
}

int main (int argc, char **argv)
{
	gtk_set_locale ();
	gtk_init (&argc, &argv);
	glade_init ();

	umask (022);

	// glade 파일 초기화
	if (0 == access (INST_PREFIX"/share/gzinc/gzinc.glade", R_OK))
	{
		gp_xml_main = glade_xml_new (INST_PREFIX"/share/gzinc/gzinc.glade",
								NULL, NULL);
	}
	else if (0 == access ("../layout/gzinc.glade", R_OK))
	{
		gp_xml_main = glade_xml_new ("../layout/gzinc.glade", 
								NULL, NULL);
	}
	else
	{
		fprintf (stderr, "gzinc.glade file not found, Abort Execution.\n");
	}

	glade_xml_signal_autoconnect (gp_xml_main);
	
	config_read (".gzinc", 1);			// 기본 설정 파일
	gs_config_init ();
	
	config_read (".gzinc_rend", 2);	// 렌더러 설정 파일
	gs_rend_conf_init ();
	gs_treeview_init ();

	if (NULL != (const gchar *) config_keyval_get ("exec_dir"))
		zinc_gamelist_builder ((const gchar *) config_keyval_get ("exec_dir"));
	else
		zinc_gamelist_builder ("zinc");

	gtk_main ();

	return EXIT_SUCCESS;
}
